package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.jk_interface.action;

import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.jk_interface.vo.EncryptionResponseObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.jk_interface.vo.ResponseObject;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @Auther jianggang
 * @Date 2018/10/24 14:12:49
 * @Description
 */
@Api(value = "交科通道接口")
@FeignClient(name = "iov-sjjh-servicenode-supplier-10000001")
public interface JKChannelAction {

    /**
     *
     * @param channelId
     * @param outTime
     * @param customBody
     * @return
     */
    @ApiOperation(value = "交科身份证二要素验证通道")
    @PostMapping(value = "/checkIdCardForJK.do")
    ResponseObject TwoParamIdCard(
            @ApiParam(name = "通道id", required = true)
            @RequestHeader(name = "channelId", required = true) String channelId,
            @ApiParam(name = "超时时间", required = false)
            @RequestParam(name = "outTime", required = false) Integer outTime,
            @ApiParam(name = "身份证二要素验证", value = "传入JSON字符串", required = true)
            @RequestParam(name = "customBody", required = true) String customBody
    );

    @ApiOperation(value = "移动三要素加密版接口" , notes = "")
    @PostMapping(value = "/encryptionMobileCheck.do")
    EncryptionResponseObject encryptionMobileCheck(
            @RequestHeader(name = "channelId") String channelId,
            @RequestParam(name = "outTime", required = true) int outTime,
            @RequestParam(name = "customBody", required = true) String customBody);

    @ApiOperation(value = "测试移动三要素加密版测试接口" , notes = "")
    @PostMapping(value = "/encryptionMobileCheckNew.do")
    ChannelTypeHandleResponseObject encryptionMobileCheckNew(
            @RequestHeader(name = "channelId") String channelId,
            @RequestParam(name = "outTime", required = true) int outTime,
            @RequestParam(name = "customBody", required = true) String customBody);

    @ApiOperation(value = "车辆抵押接口" , notes = "")
    @PostMapping(value = "/vehicleMortgage.do")
    ChannelTypeHandleResponseObject vehicleMortgage(
            @RequestHeader(name = "channelId") String channelId,
            @RequestParam(name = "outTime", required = true) int outTime,
            @RequestParam(name = "customBody", required = true) String customBody);
}
